Imports System.Threading

Namespace IPS

    Public Class IIPSsoap
        Private tform As mForm

#Region "IIPS"
        Private ips_I_soap As IIPSSOAPServer.IIPSSOAPServerservice
        Private ips_I_oms As IIPSObjectManager.IIPSObjectManagerservice
        Private ips_I_vms As IIPSVariableManager.IIPSVariableManagerservice
        Private ips_I_fs20 As IIPSFS20.IIPSFS20service
        Private ips_I_lcn As IIPSLCNModule.IIPSLCNModuleservice
        Private ips_C_str_id As String
        Private ips_C_rx As String
        Private ips_C1D_rx_queue(9) As String
        Private ips_C_queue_index As Integer
        Private ips_T_qwriter As Thread
#End Region

        Public Enum IIPSVarType
            vInt = 0
            vFloat = 1
            vString = 2
            vBoolean = 3
        End Enum

        Public Enum IIPSInterfaceType
            iFS20 = 0
            iLCN = 1
        End Enum

        Public Sub New(ByRef tform As mForm)
            Me.tform = tform
            ips_I_soap = New IIPSSOAPServer.IIPSSOAPServerservice
            ips_I_vms = New IIPSVariableManager.IIPSVariableManagerservice
            ips_I_oms = New IIPSObjectManager.IIPSObjectManagerservice
            ips_I_fs20 = New IIPSFS20.IIPSFS20service
            ips_I_lcn = New IIPSLCNModule.IIPSLCNModuleservice
            ips_T_qwriter = New Thread(AddressOf WriteQueue)
            ips_T_qwriter.IsBackground = True
            ips_T_qwriter.Start()
        End Sub

        Public Sub main()
            ips_C_str_id = ips_I_soap.StartSession(IIPSSOAPServer.TFilterType.ftExcludeFilter)
            While True
                Try
                    Dim tmp_msg() As IIPSSOAPServer.TIPSMessage
                    tmp_msg = ips_I_soap.GetSessionMessages(ips_C_str_id)
                    Dim tmp_index As Integer
                    '/*--------------------------------------------------------*/
                    '/*      berprfen auf MessageID == Variable OnUpdate     */
                    '/* Dadurch auch gleich berprfung, ob Sender == Variable */
                    '/*--------------------------------------------------------*/
                    tmp_index = Array.FindIndex(tmp_msg, AddressOf ChkMsgID)
                    If tmp_index >= 0 Then
                        Dim var_obj As IIPSVariableManager.TIPSVariable
                        var_obj = ips_I_vms.GetVariable(tmp_msg(tmp_index).SenderID)
                        Dim db_dc(0) As Data.DataColumn
                        db_dc(0) = tform.db_dt.Columns.Item("StatVarID")
                        tform.db_dt.PrimaryKey = db_dc
                        Dim foundrow As Data.DataRow
                        foundrow = tform.db_ds.Tables("ips_switch_devices").Rows.Find(tmp_msg(tmp_index).SenderID)
                        If Not foundrow Is Nothing Then
                            '/* Datenbergabe Statusnderung Hausautomation */
                            ips_C_rx = "ips|update|" & tmp_msg(tmp_index).SenderID.ToString & "|" & var_obj.VariableValue.ValueBoolean.ToString.ToLower
                            ips_C1D_rx_queue(ips_C_queue_index) = ips_C_rx
                            If ips_C_queue_index < 9 Then
                                ips_C_queue_index += 1
                            Else
                                ips_C_queue_index = 0
                            End If
                            '/* Datenbank updaten */
                            Select Case var_obj.VariableValue.ValueBoolean
                                Case True
                                    foundrow.Item("Status") = "1"
                                Case False
                                    foundrow.Item("Status") = "0"
                            End Select
                            Dim cb As Data.OleDb.OleDbCommandBuilder = New Data.OleDb.OleDbCommandBuilder(tform.db_da)
                            tform.db_da.Update(tform.db_ds, "ips_switch_devices")
                            cb = Nothing
                        ElseIf tmp_msg(tmp_index).SenderID = tform.ips_C_str_id_vol Then
                            '/* Datenbergabe Lautstrke Multi Room Audio */
                            Shell("nircmdc setsysvolume " & Int(var_obj.VariableValue.ValueInteger / 100 * 65535).ToString, AppWinStyle.Hide)
                            tform.mra_C_vol_av = var_obj.VariableValue.ValueInteger
                            ips_C_rx = "mra|setvolume|" & var_obj.VariableValue.ValueInteger.ToString
                            ips_C1D_rx_queue(ips_C_queue_index) = ips_C_rx
                            If ips_C_queue_index < 9 Then
                                ips_C_queue_index += 1
                            Else
                                ips_C_queue_index = 0
                            End If
                        ElseIf tmp_msg(tmp_index).SenderID = tform.ips_C_str_id_phone Then
                            '/* Datenbergabe Anrufsignal */
                            ips_C_rx = "sys|phone|" & var_obj.VariableValue.ValueString
                            ips_C1D_rx_queue(ips_C_queue_index) = ips_C_rx
                            If ips_C_queue_index < 9 Then
                                ips_C_queue_index += 1
                            Else
                                ips_C_queue_index = 0
                            End If
                            Shell("C:\Programme\Sconi Center\sconicenter.exe [ircode]Pause", AppWinStyle.MinimizedNoFocus)
                        ElseIf tmp_msg(tmp_index).SenderID = tform.ips_C_str_id_door Then
                            '/* Datenbergabe Trsignal */
                            ips_C_rx = "sys|door|" & var_obj.VariableValue.ValueBoolean.ToString.ToLower
                            ips_C1D_rx_queue(ips_C_queue_index) = ips_C_rx
                            If ips_C_queue_index < 9 Then
                                ips_C_queue_index += 1
                            Else
                                ips_C_queue_index = 0
                            End If
                            Shell("C:\Programme\Sconi Center\sconicenter.exe [ircode]Pause", AppWinStyle.MinimizedNoFocus)
                        End If
                    End If
                Catch ex As Exception
                    If Not ips_I_soap.IsSessionValid(ips_C_str_id) Then
                        Try
                            ips_C_str_id = ips_I_soap.StartSession(IIPSSOAPServer.TFilterType.ftExcludeFilter)
                        Catch _ex As Exception
                            '/* nothing to do */
                        End Try
                    End If
                End Try
            End While
        End Sub

        Public Function SetDevice(ByVal InstanceID As String, ByVal Value As Boolean, ByVal Type As IIPSInterfaceType) As Boolean
            Try
                Select Case Type
                    Case IIPSInterfaceType.iFS20
                        Dim tmp_tid As New IIPSFS20.TIDHeader
                        tmp_tid.ID = InstanceID
                        ips_I_fs20.SwitchMode(Value)
                        tmp_tid = Nothing
                    Case IIPSInterfaceType.iLCN
                        Dim tmp_tid As New IIPSLCNModule.TIDHeader
                        tmp_tid.ID = InstanceID
                        '/* stuff to do */
                        tmp_tid = Nothing
                End Select
                Return True
            Catch ex As Exception
                Return False
            End Try
        End Function

        Public Function SetValue(ByVal VariableID As String, ByVal Value As String, ByVal Type As IIPSVarType) As Boolean
            Try
                Select Case Type
                    Case IIPSVarType.vInt
                        ips_I_vms.WriteVariableInteger(VariableID, System.Convert.ToInt32(Value))
                    Case IIPSVarType.vFloat
                        ips_I_vms.WriteVariableFloat(VariableID, System.Convert.ToDouble(Value))
                    Case IIPSVarType.vString
                        ips_I_vms.WriteVariableString(VariableID, Value)
                    Case IIPSVarType.vBoolean
                        ips_I_vms.WriteVariableBoolean(VariableID, System.Convert.ToBoolean(Value))
                End Select
                Return True
            Catch ex As Exception
                Return False
            End Try
        End Function

        Private Function ChkMsgID(ByVal Msg As IIPSSOAPServer.TIPSMessage) As Boolean
            If Msg.Message = 10063 Then
                Return True
            Else
                Return False
            End If
        End Function

        Private Sub WriteQueue()
            Dim tmp_index As Integer
            Do
                If Not ips_C1D_rx_queue(tmp_index) = vbNullString Then
                    While Not TcpServer_Class.TXdata Is vbNullString
                        Thread.SpinWait(1)
                    End While
                    TcpServer_Class.TXdata = ips_C1D_rx_queue(tmp_index)
                    ips_C1D_rx_queue(tmp_index) = vbNullString
                End If
                If tmp_index < 9 Then
                    tmp_index += 1
                Else
                    tmp_index = 0
                End If
                Thread.Sleep(20)
            Loop
        End Sub

    End Class

End Namespace
